
/** INCLUDES *******************************************************/
#include <stdlib.h>
#include <timers.h>
#include <delays.h>
#include <string.h>
#include <usart.h>

#include "my_xlcd.h"


#pragma config MCLRE = ON
#pragma config WDT = OFF 
#pragma config OSC=HSPLL
#pragma config FCMEN=OFF
#pragma config IESO=OFF
#pragma config PWRT=OFF
#pragma config LPT1OSC=OFF
#pragma config BORV=3		
#pragma config STVREN=ON
#pragma config DEBUG=OFF
#pragma config WRTB=ON
#pragma config PBADEN=OFF
#pragma config LVP=OFF

#pragma udata

static char hello[] = "Initializing...";

    
void LowISR(void);
void HighISR(void);

static volatile char c;

#pragma code

#pragma interruptlow LowISR
void LowISR(void)
  {
  }



#pragma interruptlow HighISR
void HighISR(void)
  {	
    if (PIR1bits.RCIF)
      {

          PIR1bits.RCIF = 0;
            c = ReadUSART();
            if (c == '$') lcd_crlf();
            lcd_printc(c);
      }
   
  }




#pragma code lowVector=0x18
void LowVector(void){_asm goto LowISR _endasm}

#pragma code highVector=0x8
void HighVector(void){_asm goto HighISR _endasm}

#pragma code  // Return to default code section




void main(void)
  {   
    char c;
    
    ADCON1 |= 0x0F;                 // Default all pins to digital
          
     INTCON=0;            //make sure interrupts are disable
     INTCONbits.GIE=1;    //enable global interrupts
     INTCONbits.PEIE=1;   //enable peripheral interrupts
    // INTCONbits.TMR0IE=1; //enable TMR0 overflow interrupt enable bit
    // INTCON=0xe0;            //all 4 lines above combined

    lcd_open();
    
    lcd_prints(hello);
    
   OpenUSART( 
        USART_TX_INT_OFF & 
        USART_RX_INT_ON &
        USART_ASYNCH_MODE &
        USART_EIGHT_BIT &
        USART_BRGH_LOW &              
        USART_CONT_RX
        ,
        129
      );
             
    while(1)
      {
    
      }
  }

